﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace ColorDialog_Problem
{
    public partial class Form1 : Form
    {
        private bool _drawState = true;
        private string _shapeName01 = "Line01";
        private string _shapeName02 = "Line02";

        private Line01 _line01 = new();
        private Line02 _line02 = new();

        private int _line01Alpha = 255;
        private int _line01Red = 255;
        private int _line01Green = 201;
        private int _line01Blue = 14;
        private int _line01Width = 10;

        private int _line02Alpha = 255;
        private int _line02Red = 0;
        private int _line02Green = 0;
        private int _line02Blue = 255;
        private int _line02Width = 10;

        private Point _line01StartCoords;
        private Point _line01EndCoords;

        private Point _line02StartCoords;
        private Point _line02EndCoords;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            InitializeShapes();
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            _drawState = true;

            _line01.Draw(e.Graphics);
            _line02.Draw(e.Graphics);
        }
        private void CmdColorLines_Click(object sender, EventArgs e)
        {
            if (DlgColor.ShowDialog() == DialogResult.OK)
            {
                _line01Red = DlgColor.Color.R;
                _line01Green = DlgColor.Color.G;
                _line01Blue = DlgColor.Color.B;
                _line02Red = DlgColor.Color.R;
                _line02Green = DlgColor.Color.G;
                _line02Blue = DlgColor.Color.B;

                _line01 = new Line01(_line01Alpha, _line01Red, _line01Green, _line01Blue, _line01Width, DashStyle.Dash)
                { Line01StartLocation = _line01StartCoords, Line01EndLocation = _line01EndCoords };


                _line02 = new Line02() { Line02StartLocation = _line02StartCoords, Line02EndLocation = _line02EndCoords };
                _line02.Alpha = Convert.ToInt32(NudAlpha.Value); 
                _line02.Red = _line02Red;
                _line02.Green = _line02Green;
                _line02.Blue = _line02Blue;
                _line02.Width = _line02Width;
                _line02.DStyle = DashStyle.Dash;
            }

            Invalidate();
        }

        private void NudAlpha_ValueChanged(object sender, EventArgs e)
        {
            _line01 = new Line01(Convert.ToInt32(NudAlpha.Value), _line01Red, _line01Green, _line01Blue, _line01Width, DashStyle.Dash)
                { Line01StartLocation = _line01StartCoords, Line01EndLocation = _line01EndCoords };

            _line02 = new Line02() { Line02StartLocation = _line02StartCoords, Line02EndLocation = _line02EndCoords };
            _line02.Alpha = Convert.ToInt32(NudAlpha.Value);
            _line02.Red = _line02Red;
            _line02.Green = _line02Green;
            _line02.Blue = _line02Blue;
            _line02.Width = _line02Width;
            _line02.DStyle = DashStyle.Dash;

            Invalidate();
        }

        public void InitializeShapes()
        {
            _line01StartCoords = new Point(250, 150);
            _line01EndCoords = new Point(560, 150);

            _line02StartCoords = new Point(250, 200);
            _line02EndCoords = new Point(560, 200);

            _line01 = new Line01(_line01Alpha, _line01Red, _line01Green, _line01Blue, _line01Width, DashStyle.Dash)
                { Line01StartLocation = _line01StartCoords, Line01EndLocation = _line01EndCoords };


            _line02 = new Line02()
            { Line02StartLocation = _line02StartCoords, Line02EndLocation = _line02EndCoords };
            _line02.Alpha = _line02Alpha;
            _line02.Red = 0;
            _line02.Green = 0;
            _line02.Blue = 255;
            _line02.Width = _line02Width;
            _line02.DStyle = DashStyle.Dash;

            Invalidate();
        }


    }
}
